<template>
	<view class="risk-record-page">
		<u-sticky>
			<view class="filter-bar">
				<view class="filter filter-date-range" @click="handleShowPicker({title: '时间区间', name: 'dateRange'})">
					<text>{{dateFilterTxt}}</text>
					<u-icon size="14" style="margin-left: 4px;" name="arrow-down"></u-icon>
				</view>
				<uni-search-bar class="search-bar" radius="100" v-model="keyword" @confirm="handleSearch"
					@cancel="handleCancelSearch" @clear="handleCancelSearch" placeholder="搜索" cancel-button="none">
					<uni-icons slot="searchIcon" color="#999999" size="16" type="search" class="search-slot" />
				</uni-search-bar>
				<view class="filter filter-status" @click="handleShowPicker({title: '状态', name: 'status'})">
					<text>{{statusFilterTxt}}</text>
					<u-icon size="14" style="margin-left: 4px;" name="arrow-down"></u-icon>
				</view>
			</view>
		</u-sticky>
		<view class="main">
			<view class="content-list">
				<common-card :dataSource="item" v-for="item in lists" class="content" @click="showDetail(item.ID)">
					<view>
						<view class="field">
							<text class="label">版本号：</text>
							<text class="value">{{item.VERSION_NUM}}</text>
						</view>
						<view class="field">
							<text class="label">需求类别：</text>
							<text class="value">{{item.Nav_LawType.NAME}}</text>
						</view>
						<view class="field">
							<text class="label">制修订日期：</text>
							<text class="value">{{item.UPDATE_TIME.substring(0,10)}}</text>
						</view>
						<view class="field">
							<text class="label">上传人：</text>
							<text class="value">{{item.Nav_User.NAME}}</text>
						</view>
					</view>
				</common-card>
			</view>
			<view v-if="!lists.length" class="empty-wrap">
				<u-empty text="暂无数据" icon="/static/empty@2x.png">
				</u-empty>
			</view>
		</view>
		<u-picker :show="comPickerInfo.showPicker" :columns="comPickerInfo.columns" @confirm="onConfirmPicker"
			:defaultIndex="[0]" @cancel="closePicker"></u-picker>
	</view>
</template>

<script>
	import {
		getRequestOrderPage
	} from '../../../../services/apply/FOServices/FOServices.js'
	import {
		extendInclude,
		extendRule,
		initFilter
	} from '../../../../utils/common'

	export default {
		data() {
			return {
				pageIndex: 1,
				total: 0,
				lists: [],
				keyword: '',
				searchStartTime: '',
				filterStatus: null,
				dateFilterTxt: '时间区间',
				statusFilterTxt: '状态筛选',
				comPickerInfo: {
					showPicker: false,
					columns: [],
					title: '',
					name: ''
				}
			}
		},
		onLoad() {
			this.loadData()
		},
		methods: {
			handleSearch(obj) {
				this.keyword = obj.value
			},
			handleCancelSearch() {
				this.keyword = ''
			},
			loadData() {
				const orgId = uni.getStorageSync('orgId')
				const json = initFilter(orgId, "", "CREATE_TIME", 1, this.pageIndex)
				extendInclude(json, "Nav_LawType")
				extendInclude(json, "Nav_User")
				if (this.keyword) {
					extendRule(json, 'NAME', 9, this.keyword)
				}
				if (this.searchStartTime) {
					extendRule(json, 'TRAIN_START_TIME', 6, this.searchStartTime)
				}
				if (this.filterStatus !== null) {
					extendRule(json, 'STATUS', 1, this.filterStatus)
				}
				getRequestOrderPage(json, "/LR/Law/OrderPaged").then(res => {
					this.total = res.TotalCount;
					let newRes = (res.Data || []).map(i => {
						return {
							...i,
							title: i.NAME,
						}
					})

					if (this.pageIndex !== 1) {
						this.lists = this.lists.concat(newRes)
					} else {
						this.lists = newRes
					}
				})
			},
			showDetail(id) {
				uni.navigateTo({
					url: '/pages/apply/subPages/LR/1LawShow?ID=' + id
				})
			},
			handleShowPicker(p) {
				let column = []
				if (p.name === 'dateRange') {
					column = ['全部', '当天', '最近三天', '最近一周', '最近一月']
				}
				if (p.name === 'status') {
					column = ['全部', '草稿', '签到中', '归档']
				}
				this.comPickerInfo = {
					showPicker: true,
					title: p.title,
					name: p.name,
					columns: [column]
				}
			},
			onConfirmPicker(e) {
				if (this.comPickerInfo.name === 'dateRange') {
					let currentDate = new Date();
					if (e.indexs[0] === 2) {
						currentDate.setDate(currentDate.getDate() - 3);
					} else if (e.indexs[0] === 3) {
						currentDate.setDate(currentDate.getDate() - 7);
					} else if (e.indexs[0] === 4) {
						currentDate.setDate(currentDate.getMonth());
					}
					if (e.indexs[0] === 0) {
						this.searchStartTime = ''
						this.dateFilterTxt = '时间区间'
					} else {
						this.dateFilterTxt = e.value[0]
						this.searchStartTime = uni.$u.timeFormat(currentDate, 'yyyy-mm-dd 00:00:00');
					}
				}
				if (this.comPickerInfo.name === 'status') {
					if (e.indexs[0] === 1) {
						this.filterStatus = 0
					} else if (e.indexs[0] === 2) {
						this.filterStatus = 1
					} else if (e.indexs[0] === 3) {
						this.filterStatus = 2
					} else if (e.indexs[0] === 4) {
						this.filterStatus = 3
					} else if (e.indexs[0] === 5) {
						this.filterStatus = 4
					} else if (e.indexs[0] === 6) {
						this.filterStatus = 5
					} else if (e.indexs[0] === 7) {
						this.filterStatus = 6
					}
					if (e.indexs[0] === 0) {
						// 全部
						this.filterStatus = null
						this.statusFilterTxt = '状态筛选'
					} else {
						this.statusFilterTxt = e.value[0]
					}
				}
				this.closePicker()
			},
			closePicker() {
				this.comPickerInfo = {
					showPicker: false,
					columns: [],
					title: '',
					name: ''
				}
			},
		},
		onReachBottom() {
			// 页码 +1
			if (this.total > 10 * this.pageIndex)
				this.pageIndex++
		},
		watch: {
			pageIndex(n, o) {
				this.loadData()
			},
			keyword(n, o) {
				this.pageIndex = 1
				this.keyword = n
				this.loadData()
			},
			searchStartTime(n, o) {
				this.pageIndex = 1
				this.searchStartTime = n
				this.loadData()
			},
			filterStatus(n, o) {
				this.pageIndex = 1
				this.filterStatus = n
				this.loadData()
			}
		}
	}
</script>

<style>
	.risk-record-page {
		position: relative;
	}

	.risk-record-page .main {
		padding: 0px 16px;
		position: relative;
	}

	.risk-record-page>>>.uni-searchbar {
		padding: 0px;
		display: flex;
		align-items: center;
		font-size: 12px;

		.uni-searchbar__box {
			height: 30px;
		}

		.uni-searchbar__box-icon-clear {
			display: flex;
			align-items: center;
		}

		.uni-input-placeholder {}

		.uni-searchbar__box-search-input {
			font-size: 12px;
		}

		.uni-searchbar__text-placeholder {
			font-size: 12px;
			margin-left: 0px;
		}

		.uni-text {
			font-size: 12px;
		}
	}

	.filter-bar .search-bar {
		margin-left: 20px;
		margin-right: 20px;
		width: 100%;
		display: flex;
		flex: 1;
		align-items: center;
		font-size: 12px;
	}

	.filter-bar {
		display: flex;
		justify-content: space-between;
		align-items: center;
		background-color: #ffffff;
		padding: 10px 16px 10px 16px;
		box-shadow: 0px 0px 5px 0px #eaedf4;
	}

	.filter-bar .filter {
		display: flex;
		align-items: center;
		font-size: 12px;
		line-height: 18px;
		color: #333;
	}

	.content-list {
		padding: 10px 0;
	}

	.content .field {
		font-size: 12px;
		line-height: 18px;
		margin-bottom: 4px;
	}

	.content .field .label {
		color: #666;
	}

	.content .field .value {
		color: #333333;
	}

	.status {
		background-color: rgba(5, 109, 232, 0.1);
		color: #056DE8;
		padding: 0px 5px 0px 5px;
		border-radius: 5px;
	}
</style>